/*
 * Copyright (c) 2003 wwcube@yahoo.co.jp
 */

/*
 * Log
 */
#include <stdio.h>
#include <stdarg.h>

#include "tracelog.h"

static FILE *s_tracelog_fp;
static int s_tracelog_level;

int tracelog_setlevel(int level)
{
	s_tracelog_level = level;
	return 0;
}

int tracelog_open(char *fname)
{
	FILE *fp;
	fp = fopen(fname, "a+");
	if (fp == NULL) {
		perror("fopen");
		fprintf(stderr, "can not open logfile (\"%s\")\n", fname);
		return -1;
	}
	s_tracelog_fp = fp;

	return 0;
}

int tracelog(int level, char *format, ...)
{
	FILE *fp;
	va_list args;

	if ((s_tracelog_level & level) == 0) {
		return 0;
	}

	fp = s_tracelog_fp;
	if (s_tracelog_fp == NULL) {
		fp = stderr;
	}

	va_start(args, format);
	if (vfprintf(fp, format, args) < 0) {
		fprintf(stderr, "vfprintf() failed - ");
		vfprintf(stderr, format, args);
	}
	va_end(args);

	fflush(fp);

	return 0;
}

int tracelog_close()
{
	if (s_tracelog_fp != NULL) {
		fclose(s_tracelog_fp);
		s_tracelog_fp = NULL;
	}
	return 0;
}
