/*
 * Copyright (c) 2003 wwcube@yahoo.co.jp
 */
/*
 * Copyright (c) 1999-2000, Qute Corporation. All rights reserved.
 */
#ifndef WWCOMM_H_INCLUDED
#define WWCOMM_H_INCLUDED

#ifdef  __cplusplus
extern "C" {
#endif

#define ERR_SIO_OK			0x0000
#define ERR_SIO_BUSY		0x8100
#define ERR_SIO_TIMEOUT		0x8101
#define ERR_SIO_OVERRUN		0x8102
#define ERR_SIO_CANCEL		0x8103

#define COMM_SPEED_9600		0
#define COMM_SPEED_38400	1

void comm_open(void);
void comm_close(void);
int comm_send_char(unsigned char byte);
int comm_receive_char(void);
int comm_receive_with_timeout(int timeout);
int comm_send_string(char *string);
int comm_send_block(void *buffer, int size);
int comm_receive_block(void *buffer, int size, int *bytes);
void comm_set_timeout(int receive_timeout, int send_timeout);
void comm_set_baudrate(int speed);
int comm_get_baudrate(void);

/* Any cancel key is mapped to CTRL-C */ 
void comm_set_cancel_key(unsigned cancel_key_pattern);
unsigned comm_get_cancel_key(void);

#if notyet
int comm_xmodem(xmodeminfo *xmodem);
#endif

/* NON PORTABLE FUNCTIONS */
int comm_set_portnumber_np(int commport);
int comm_get_portnumber_np();

#ifdef  __cplusplus
}
#endif

#endif
